//
//  AsynNetwork.m
//  PTM
//
//  Created by yuwei on 2011/5/11.
//  Copyright 2011年 __MyCompanyName__. All rights reserved.
//

#import "AsynNetwork.h"
#import "SocketClient.h"

@implementation AsynNetwork

@synthesize data, url;
@synthesize delegate;
#pragma mark - object lifecycle

- (id) init {
    self = [super init];
    if (!self) {
        return nil;
    }
    data = [[NSMutableData alloc] init];
    return self;
}

- (void) dealloc {
    [data release];
    [connection release];
    [super dealloc];
}

#pragma mark - asyn download

- (NSData *)asynDownloadData: (NSURL *)aUrl{
    
    NSData *synData = [NSData dataWithContentsOfURL:aUrl];
    return synData;
    
}

- (void)asynDownloadData:(NSURL *)aUrl FromPeer:(NSNetService *)peer {
    self.url = aUrl;
    NSString *strUrl = [NSString stringWithFormat:@"%@://%@%@", [url scheme], [url host], [url path]];
    SocketClient *sClinet = [[SocketClient alloc] initWithService:peer url:strUrl delegate:self];
    [sClinet runConnection];
}

#pragma mark - NSURLConnection Delegate

- (void)connection:(NSURLConnection *)connection didReceiveResponse:(NSURLResponse *)response
{
    // This method is called when the server has determined that it
    // has enough information to create the NSURLResponse.
    
    // It can be called multiple times, for example in the case of a
    // redirect, so each time we reset the data.
    
    [data setLength:0];
}

- (void) connection:(NSURLConnection *)connection didReceiveData:(NSData *)newData {
    [data appendData:newData];
}

- (void) connection:(NSURLConnection *)connection didFailWithError:(NSError *)error {
    [delegate asynDownload:self didFailWithError:error];
}

- (void) connectionDidFinishLoading:(NSURLConnection *)connection { 
    [delegate asynDownloaddidFinish:self]; 
}

#pragma mark - Socket Client delegate

- (void)socketClientDidOpenConnection:(SocketClient *) socketClient{

}
- (void)socketClientDidReceiveError:(SocketClient *) socketClient {

}
- (void)socketClientWillBeginReceivingData:(SocketClient *) socketClient{

}
- (void)socketClientDidFinishReceivingData:(SocketClient *) socketClient{
    [data release];
    if (socketClient.respond != nil) {
        data = [[NSMutableData alloc] initWithData:socketClient.respond];
    }else
        data = nil;
    [socketClient autorelease];
    [delegate asynDownloaddidFinish:self];
}


@end
