//
//  BonjourListViewController.m
//  PTM
//
//  Created by yuwei on 2011/5/10.
//  Copyright 2011年 __MyCompanyName__. All rights reserved.
//

#import "BonjourListViewController.h"
#import "BonjourDiscoverSocketClient.h"
#import "BonjourPeer.h"
#import "SocketClient.h"
#import "Content.h"

@implementation BonjourListViewController

@synthesize bdsClient;// sClient;
@synthesize modelManager;
@synthesize webview;

- (id)initWithStyle:(UITableViewStyle)style
{
    self = [super initWithStyle:style];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)dealloc
{
    if (webview != nil){
        webview.delegate = nil;
        [webview release];
    }
    [modelManager release];
    [bdsClient release];
    [super dealloc];
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
    BonjourDiscoverSocketClient *aClient = [[BonjourDiscoverSocketClient alloc] init];
    aClient.delegate = self;
    self.bdsClient = aClient;
    [aClient release];
    webview = nil;
    page = nil;
    lastUrl = nil;
    downloadPool = nil;
    
    // Uncomment the following line to preserve selection between presentations.
    // self.clearsSelectionOnViewWillAppear = NO;
 
    // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
    // self.navigationItem.rightBarButtonItem = self.editButtonItem;
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    self.modelManager.asyDelegate = self;
    [bdsClient startSearchService];
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
}

- (void)viewWillDisappear:(BOOL)animated
{
    [super viewWillDisappear:animated];
}

- (void)viewDidDisappear:(BOOL)animated
{
    [super viewDidDisappear:animated];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

#pragma mark - Table view data source
- (NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section {
    BonjourPeer *peer = (BonjourPeer *) [services objectAtIndex:section];
    return [peer.peer name];
}

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    // Return the number of sections.
    if (!services) {
        return 0;
    }
    return [services count];
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    // Return the number of rows in the section.
    BonjourPeer *peer = (BonjourPeer *) [services objectAtIndex:section];
    return [peer.set count];
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *CellIdentifier = @"Cell";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier] autorelease];
    }
    
    // Configure the cell...
    BonjourPeer *peer = (BonjourPeer *) [services objectAtIndex:indexPath.section];
    
    NSSet *sectionSet = peer.set;
    NSSortDescriptor *sortDescriptor = [[NSSortDescriptor alloc] initWithKey:@"description" ascending:NO];
    NSArray *sortDescriptors = [[NSArray alloc] initWithObjects:sortDescriptor, nil];
    NSArray *sectionArray = [sectionSet sortedArrayUsingDescriptors:sortDescriptors];
    cell.textLabel.text = [sectionArray objectAtIndex:indexPath.row];
    [sortDescriptor release];
    [sortDescriptors release];
    
    return cell;
}


#pragma mark - Table view delegate

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Navigation logic may go here. Create and push another view controller.
    /*
     <#DetailViewController#> *detailViewController = [[<#DetailViewController#> alloc] initWithNibName:@"<#Nib name#>" bundle:nil];
     // ...
     // Pass the selected object to the new view controller.
     [self.navigationController pushViewController:detailViewController animated:YES];
     [detailViewController release];
     */
    if (downloadPool != nil) {
        [downloadPool release];
        downloadPool = nil;
    }
    downloadPool = [[NSMutableSet alloc] init];
    
    if (webview != nil) {
        webview.delegate = nil;
        [webview release];
        webview = nil;
    }
    webview = [[UIWebView alloc] init];
    webview.delegate = self;
    webview.scalesPageToFit = YES;
    lastUrl = [NSURL URLWithString:[NSString stringWithFormat:@"http://%@", 
                  [self tableView:self.tableView cellForRowAtIndexPath:indexPath].textLabel.text] ];
    [lastUrl retain];
    UIViewController *vc = [[UIViewController alloc] init];
    vc.view = webview;
    
   BonjourPeer *bPeer = (BonjourPeer *) [services objectAtIndex:indexPath.section];
    [modelManager usePeer:bPeer.peer];

    
    [webview loadRequest:[NSURLRequest requestWithURL:lastUrl]];
    [self.navigationController pushViewController:vc animated:YES];
    [vc release];
}

#pragma mark - BonjourDiscoverSocketClient Delegate
- (void)servicesDidChange: (BonjourDiscoverSocketClient *) client{
    services = [self.bdsClient.services copy];
    [self.tableView reloadData];
}


#pragma mark - UIWebView Delegate
- (void) webViewDidFinishLoad:(UIWebView *)aWebView {

}

- (void) webView:(UIWebView *)aWebView didFailLoadWithError:(NSError *)error {

}
- (void)webViewDidStartLoad:(UIWebView *)webView{
}
#pragma mark - AsynModel dalegate
- (void) AsynModelWillRequestContent: (NSString *) reqStr {

    [downloadPool addObject: reqStr];
}

- (void) AsynModelDidInsertContent: (Content *) newContent {
    [downloadPool removeObject:newContent.url];
    if ([downloadPool count] > 0) {
        return;
    }
    
    Content *pp = [self.modelManager contentRequest:lastUrl];
    if (pp == nil) {
        return;
    }
    [self.webview stopLoading];
    [self.webview loadData:pp.context MIMEType:pp.miniType textEncodingName:@"utf-8" baseURL:[NSURL URLWithString:pp.url]];
    
    if ([[lastUrl absoluteString] compare:newContent.url] == NSOrderedSame) {
        NSURL *url = [self.webview.request URL];
        NSURL *aUrl = [NSURL URLWithString:[[webview.request URL] absoluteString]];
        if ([[aUrl absoluteString] length] > 0) {
            lastUrl = [aUrl retain];
        }
        NSArray *components = [url pathComponents];
        for (int i = [components count] ; i > 0  ; i--) {
            
            NSMutableString *searchParent = [NSMutableString stringWithFormat:@"%@://%@", [url scheme], [url host]];
            for (int q = 0; q < i; q++) {
                if (q < 2) {
                    [searchParent appendString:[components objectAtIndex:q]];
                }else{
                    [searchParent appendFormat:@"/%@", [components objectAtIndex:q]];
                }
            }
            NSURL *addCount = [NSURL URLWithString:searchParent];
            [modelManager addHtmlCount:addCount];
        }
    }
}
@end
