//
//  BonjourSocketServer.h
//  SampleMulticast
//
//  Created by yuwei on 2011/5/3.
//  Copyright 2011年 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "SocketServerRequest.h"
#import "PTMAppDelegate.h"

@protocol BonjourSocketServerDelegate;


NSString * const BonjourServerErrorDomain;

typedef enum {
    kBonjourServerCouldNotBindToIPv4Address = 1,
    kBonjourServerCouldNotBindToIPv6Address = 2,
    kBonjourServerNoSocketsAvailable = 3,
	kBonjourServerCouldNotBindOrEstablishNetService = 4
} BonjourServerErrorCode;


@interface BonjourSocketServer : NSObject <NSNetServiceDelegate, SocketServerRequestDelegate> {

    NSNetService *netService;
    NSMutableSet *connectionPool;
    CFSocketRef ipv4socket;
    
    id<BonjourSocketServerDelegate> delegate;
}

@property (nonatomic, retain) NSNetService *netService;
@property (nonatomic, retain) NSMutableSet *connectionPool;
@property (assign) CFSocketRef ipv4socket;

- (void)handleConnection:(NSString *)peerName inputStream:(NSInputStream *)readStream outputStream:(NSOutputStream *)writeStream;

- (uint16_t) setupSocketServer:(NSError **)error;
- (void) setupServer:(NSError **)error;
- (void) run;
- (void) teardown;

- (void) update;
- (void) remove: (NSString *)message;

@property (nonatomic, assign) id<BonjourSocketServerDelegate> delegate;
@end

@protocol BonjourSocketServerDelegate <NSObject>

- (NSString *) cacheList;
- (NSData *)respondToClient:(NSString *)url;

@end





