//
//  CacheListViewController.m
//  PTM
//
//  Created by yuwei on 2011/5/10.
//  Copyright 2011年 __MyCompanyName__. All rights reserved.
//

#import "CacheListViewController.h"
#import "ModelManager.h"
#import "Content.h"
@implementation CacheListViewController
@synthesize modelManager;
@synthesize webview;
#pragma mark - object lifecycle
- (id)initWithStyle:(UITableViewStyle)style
{
    self = [super initWithStyle:style];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)dealloc
{
    if (webview != nil){
        webview.delegate = nil;
        [webview release];
    }
    [modelManager release];
    [super dealloc];
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];

    UIBarButtonItem *addButton = [[UIBarButtonItem alloc] initWithBarButtonSystemItem:UIBarButtonSystemItemTrash target:modelManager action:@selector(deleteAllObject)];
    self.navigationItem.rightBarButtonItem = addButton;
    [addButton release];
    webview = nil;
    // Uncomment the following line to preserve selection between presentations.
    // self.clearsSelectionOnViewWillAppear = NO;
 
    // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
    // self.navigationItem.rightBarButtonItem = self.editButtonItem;
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    modelManager.delegate = self;
    modelManager.asyDelegate = self;
    [modelManager dontUsePear];
    [self.tableView reloadData];
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
}

- (void)viewWillDisappear:(BOOL)animated
{
    [super viewWillDisappear:animated];
}

- (void)viewDidDisappear:(BOOL)animated
{
    [super viewDidDisappear:animated];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

#pragma mark - Table view data source
- (void)configureCell:(UITableViewCell *)cell atIndexPath:(NSIndexPath *)indexPath
{
    Content *page = [self.modelManager.fetchedResultsController objectAtIndexPath:indexPath];
    
    NSURL *url = [NSURL URLWithString: page.url];
    cell.textLabel.text = [url host];
    cell.detailTextLabel.text = [NSString stringWithFormat:@"%@", [url path]];
}


- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    // Return the number of sections.
    return [[self.modelManager.fetchedResultsController sections] count];
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    // Return the number of rows in the section.
    id <NSFetchedResultsSectionInfo> sectionInfo = [[self.modelManager.fetchedResultsController sections] objectAtIndex:section];
    return [sectionInfo numberOfObjects];
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *CellIdentifier = @"Cell";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:CellIdentifier] autorelease];
    }
    
    // Configure the cell...
    [self configureCell:cell atIndexPath:indexPath];
    return cell;
}

// Override to support editing the table view.
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath
{
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        // Delete the row from the data source
        [modelManager deleteObject: indexPath];
    }   
}

#pragma mark - Table view delegate

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Navigation logic may go here. Create and push another view controller.
    /*
     <#DetailViewController#> *detailViewController = [[<#DetailViewController#> alloc] initWithNibName:@"<#Nib name#>" bundle:nil];
     // ...
     // Pass the selected object to the new view controller.
     [self.navigationController pushViewController:detailViewController animated:YES];
     [detailViewController release];
     */
    if (webview != nil) {
        webview.delegate = nil;
        [webview release];
        webview = nil;
    }
    webview = [[UIWebView alloc] init];
    webview.scalesPageToFit = YES;
    webview.delegate = self;
    Content *page = [self.modelManager.fetchedResultsController objectAtIndexPath:indexPath];
    NSURL *url = [NSURL URLWithString:page.url];
    UIViewController *vc = [[UIViewController alloc] init];
    vc.view = webview;
    
    [webview loadRequest:[NSURLRequest requestWithURL:url]];
    [self.navigationController pushViewController:vc animated:YES];
    [vc release];

    
}

#pragma mark - ModelManager delegate
- (void) beginUpdates {
    [self.tableView beginUpdates];
}
- (void) endUpdates {
    [self.tableView endUpdates];
}
- (void) inertSection:(NSUInteger) sectionIndex {
    [self.tableView insertSections:[NSIndexSet indexSetWithIndex:sectionIndex] withRowAnimation:UITableViewRowAnimationFade];
}
- (void) deleteSection:(NSUInteger) sectionIndex {
    [self.tableView deleteSections:[NSIndexSet indexSetWithIndex:sectionIndex] withRowAnimation:UITableViewRowAnimationFade];

}
- (void) inertRow: (NSIndexPath *) indexPath {
    [self.tableView insertRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:UITableViewRowAnimationFade];

}
- (void) deleteRow: (NSIndexPath *) indexPath {
    [self.tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:UITableViewRowAnimationFade];
}
- (void) configureCell: (NSIndexPath *) indexPath { 
    [self configureCell: [self.tableView cellForRowAtIndexPath:indexPath] 
            atIndexPath:indexPath];
}

#pragma mark - UIWebView Delegate
- (void) webViewDidFinishLoad:(UIWebView *)aWebView {
    NSURL *url = [aWebView.request URL];
    NSArray *components = [url pathComponents];
    for (int i = [components count] ; i > 0  ; i--) {
        
        NSMutableString *searchParent = [NSMutableString stringWithFormat:@"%@://%@", [url scheme], [url host]];
        for (int q = 0; q < i; q++) {
            if (q < 2) {
                [searchParent appendString:[components objectAtIndex:q]];
            }else{
                [searchParent appendFormat:@"/%@", [components objectAtIndex:q]];
            }
        }
        NSURL *addCount = [NSURL URLWithString:searchParent];
        [modelManager addHtmlCount:addCount];
    }
}
#pragma mark - AsynModel dalegate
- (void) AsynModelDidInsertContent: (Content *) newContent {
    [self.webview reload];
}

- (void) AsynModelWillRequestContent: (NSString *) reqStr {

}


@end
