//
//  ModelManager.h
//  PTM
//
//  Created by yuwei on 2011/5/9.
//  Copyright 2011年 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <CoreData/CoreData.h>
#import "BonjourSocketServer.h"
#import "AsynNetwork.h"
@class Content;


@protocol ModelManagerDelegate;
@protocol AsynModelDelegate;


@interface ModelManager : NSObject <NSFetchedResultsControllerDelegate, BonjourSocketServerDelegate, AsynNetworkDelegate > {


    id<ModelManagerDelegate> delegate;
    id<AsynModelDelegate> asyDelegate;
    
    BonjourSocketServer *bsServer;
    
    NSNetService *peer;
    BOOL downloadFromPeer;
    
}

@property (nonatomic, retain) NSFetchedResultsController *fetchedResultsController;
@property (nonatomic, retain) NSManagedObjectContext *managedObjectContext;
@property (nonatomic, assign) id<ModelManagerDelegate> delegate;
@property (nonatomic, assign) id<AsynModelDelegate> asyDelegate;

- (Content *) contentRequest:(NSURL *)url;
- (void) addHtmlCount:(NSURL *)url;
- (void) deleteObject: (NSIndexPath *) indexPath;
- (void) deleteAllObject;

- (NSString *) cacheList ;

@property (nonatomic, retain) BonjourSocketServer *bsServer;

- (void) usePeer:(NSNetService *)sPeer;
- (void) dontUsePear ;
@end

@protocol ModelManagerDelegate <NSObject>
- (void) beginUpdates;
- (void) endUpdates;
- (void) inertSection:(NSUInteger) sectionIndex;
- (void) deleteSection:(NSUInteger) sectionIndex; 
- (void) inertRow: (NSIndexPath *) indexPath;
- (void) deleteRow: (NSIndexPath *) indexPath; 
- (void) configureCell: (NSIndexPath *) indexPath;
@end

@protocol AsynModelDelegate <NSObject>
- (void) AsynModelDidInsertContent: (Content *) newContent;
- (void) AsynModelWillRequestContent: (NSString *) reqStr;
@end
