//
//  MyURLCache.m
//  PTM
//
//  Created by yuwei on 2011/5/9.
//  Copyright 2011年 __MyCompanyName__. All rights reserved.
//

#import "MyURLCache.h"
#import "ModelManager.h"
#import "Content.h"
#import "NetworkUtility.h"
@implementation MyURLCache

@synthesize modelManager;

- (void)dealloc {
    [modelManager release];
    [super dealloc];
}

- (NSCachedURLResponse *)cachedResponseForRequest:(NSURLRequest *)request {
    if( [[[request URL] lastPathComponent] caseInsensitiveCompare:@"receive-updates"] == NSOrderedSame )
        return nil;
    
    if( [[[request URL] lastPathComponent] caseInsensitiveCompare:@"receive-updated-views"] == NSOrderedSame )
        return nil;
    
    Content *content = [modelManager contentRequest:[request URL]];

    NSURLResponse *response;
    NSCachedURLResponse *cacheResponse;
    NSData *data = [NSData data];
    if (content != nil){
        response = [[NSURLResponse alloc] initWithURL:[NSURL URLWithString:content.url] 
                                                        MIMEType: content.miniType
                                           expectedContentLength:[content.context length] 
                                                textEncodingName:@"utf-8"];
        cacheResponse = [[NSCachedURLResponse alloc] initWithResponse:response data:content.context];
        [response release];
    }else{
        NSString *strUrl = [NSString stringWithFormat:@"%@://%@%@", [[request URL] scheme], [[request URL] host], [[request URL] path]];
        NetworkUtility *utility = [[NetworkUtility alloc] init];
        response = [[NSURLResponse alloc] initWithURL:[NSURL URLWithString: strUrl] 
                                             MIMEType: [utility identifyMineTypeWithNSURL:[request URL]]
                                expectedContentLength:[data length]
                                     textEncodingName:@"utf-8"];
        [utility release];
        cacheResponse = [[NSCachedURLResponse alloc] initWithResponse:response data:data];
        [response release];
    }
    return [cacheResponse autorelease];
}


@end
