//
//  SocketClient.h
//  SampleMulticast
//
//  Created by yuwei on 2011/5/4.
//  Copyright 2011年 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>

@protocol SocketClientDelegate;

@interface SocketClient : NSObject <NSStreamDelegate> {
    NSNetService * service;
	NSInputStream * istr;
	NSOutputStream * ostr;
    id<SocketClientDelegate> delegate;
    NSString *urlRequest;
    NSMutableData *respond;
    BOOL didSend;
}

@property (nonatomic, retain) NSNetService * service;
@property (nonatomic, retain) NSInputStream * istr;
@property (nonatomic, retain) NSOutputStream * ostr;
@property (nonatomic, assign) id<SocketClientDelegate> delegate;
@property (nonatomic, retain) NSString *urlRequest;
@property (nonatomic, retain) NSMutableData *respond;

- (id) initWithService:(NSNetService *)serviceInstance url:(NSString *)url delegate:(id<SocketClientDelegate>)anObject;
- (void) runConnection;
- (void) sendRequest;
- (void) receiveRespond;

@end


@protocol SocketClientDelegate <NSObject>

- (void)socketClientDidOpenConnection:(SocketClient *) socketClient;
- (void)socketClientDidReceiveError:(SocketClient *) socketClient;
- (void)socketClientWillBeginReceivingData:(SocketClient *) socketClient;
- (void)socketClientDidFinishReceivingData:(SocketClient *) socketClient;

@end
