//
//  SocketServerRequest.h
//  SampleMulticast
//
//  Created by yuwei on 2011/5/4.
//  Copyright 2011年 __MyCompanyName__. All rights reserved.
//
#import <Foundation/Foundation.h>


@protocol SocketServerRequestDelegate;


@interface SocketServerRequest : NSObject<NSStreamDelegate> {
	NSInputStream * istr;
	NSOutputStream * ostr;
	NSString * peerName;
    id <SocketServerRequestDelegate> delegate;
}

@property (nonatomic, retain) NSInputStream * istr;
@property (nonatomic, retain) NSOutputStream * ostr;
@property (nonatomic, retain) NSString * peerName;
@property (nonatomic, assign) id <SocketServerRequestDelegate> delegate;


- (id)initWithInputStream:(NSInputStream *)readStream 
			 outputStream:(NSOutputStream *)writeStream 
					 peer:(NSString *)peerAddress 
				 delegate:(id <SocketServerRequestDelegate>)anObject;

- (void)runProtocol;
- (NSData *)receiveData;
- (void) respondRequest: (NSData *) request;
@end

@protocol SocketServerRequestDelegate <NSObject>

- (void)socketServerRequestDidFinish:(SocketServerRequest *)request;
- (void)socketServerRequestDidReceiveError:(SocketServerRequest *)request;
- (NSData *)respondToClient:(NSString *)url;

@end

