//
//  WebBrowserViewController.m
//  PTM
//
//  Created by yuwei on 2011/5/9.
//  Copyright 2011年 __MyCompanyName__. All rights reserved.
//

#import "WebBrowserViewController.h"
#import "ModelManager.h"
#import "Content.h"
@implementation WebBrowserViewController
@synthesize webView;
@synthesize urlField;
@synthesize loadingIndicator;
@synthesize previousButton;
@synthesize nextButton;
@synthesize modelManager;

#pragma mark - object lifecycle

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)dealloc
{
    self.webView.delegate = nil;
    [modelManager release];
    [webView release];
    [urlField release];
    [loadingIndicator release];
    [previousButton release];
    [nextButton release];
    [super dealloc];
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
    [modelManager dontUsePear];    
    self.modelManager.asyDelegate = self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];    
    // Do any additional setup after loading the view from its nib.
//    modelManager = [[ModelManager alloc] init];
}

- (void)viewDidUnload
{
    self.webView.delegate = nil;
    [self setWebView:nil];
    [self setUrlField:nil];
    [self setLoadingIndicator:nil];
    [self setPreviousButton:nil];
    [self setNextButton:nil];
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

#pragma mark - web browser method

- (IBAction)previousPage:(id)sender {
    [webView goBack];
}

- (IBAction)nextPage:(id)sender {
    [webView goForward];
}

- (IBAction)loadPage:(id)sender {
    [self textFieldShouldReturn:self.urlField];
}

- (void) loadURL {
    //get url back and create an instance of NSURL
    NSURL *url = [[NSURL alloc] initWithString:urlField.text];
    
    //if there is no url scheme in urlFied, use http as the default scheme
    if([url scheme] == NULL){
        self.urlField.text = [NSString stringWithFormat:@"http://%@", urlField.text];
        [url release];
        url = [[NSURL alloc] initWithString:urlField.text];
    }
    if([[url lastPathComponent] caseInsensitiveCompare:@""] == NSOrderedSame){
        self.urlField.text = [NSString stringWithFormat:@"%@/", self.urlField.text];
        [url release];
        url = [[NSURL alloc] initWithString:urlField.text];
    }
    
    // load html code    
    [webView loadRequest:[NSURLRequest requestWithURL:url]];

    [url release];
}

#pragma mark - UIWebView Delegate Protocol

- (void) webView:(UIWebView *)aWebView didFailLoadWithError:(NSError *)error {
    
}

- (void) webViewDidFinishLoad:(UIWebView *)aWebView {
    // show activity indicator to infrom users that the page is loading
    [loadingIndicator stopAnimating];
    
    // update the statue of both previousPageButton and nextPageButton
    previousButton.enabled = webView.canGoBack;
    nextButton.enabled = webView.canGoForward;

    // update UrlField
    NSURL *url = [webView.request URL];
    urlField.text = [NSString stringWithFormat:@"%@://%@%@", 
                     [url scheme], 
                     [url host], 
                     [url path] ];
    
    NSArray *components = [url pathComponents];
    for (int i = [components count] ; i > 0  ; i--) {
        
        NSMutableString *searchParent = [NSMutableString stringWithFormat:@"%@://%@", [url scheme], [url host]];
        for (int q = 0; q < i; q++) {
            if (q < 2) {
                [searchParent appendString:[components objectAtIndex:q]];
            }else{
                [searchParent appendFormat:@"/%@", [components objectAtIndex:q]];
            }
        }
        NSURL *addCount = [NSURL URLWithString:searchParent];
        [modelManager addHtmlCount:addCount];
    }
}

- (void) webViewDidStartLoad:(UIWebView *)aWebView {
    [loadingIndicator startAnimating];
}

#pragma mark - UITextField Delegate Protocol

- (BOOL)textFieldShouldReturn:(UITextField *)textField {
    [self.urlField resignFirstResponder];
    [self loadURL];
    return YES;
}

#pragma mark - AsynModel dalegate
- (void) AsynModelDidInsertContent: (Content *) newContent {
    
    [self.webView reload];
}

- (void) AsynModelWillRequestContent: (NSString *) reqStr {
}


@end
